#include "common.h"

long getPrecedence(TOKEN_ID id)
{
	switch(id)
	{
	case T_SEMICOLON:	case T_RPAREN:
		return 1;

	case T_COMMA:
		return 2;

	case T_RBRACKET:
		return 3;

	case T_GETS:	case T_ARRAYRESIZE:	//also put +=, etc. here if implement
		return 4;

	case T_EAND:	case T_EOR:
		return 5;

	case T_BXOR:	case T_BOR:	case T_BAND:
		return 6;

	case T_EQUALS:	case T_LESS:	case T_LEQUAL:	case T_GREATER:	case T_GEQUAL:
		return 7;

	case T_SHIFTLEFT:	case T_SHIFTRIGHT:
		return 8;

	case T_PLUS:	case T_MINUS:
		return 9;

	case T_MODULUS:	case T_DIVIDE:	case T_MULTIPLY:
		return 10;

	case T_UNARYMINUS:	case T_UNARYPLUS: case T_BNOT:
		return 11;

	case T_MEMBEROF:
		return 12;

	case T_LPAREN:
		return 13;

	case T_FUNCTIONCALL:
		return 14;

	case T_LBRACKET:
		return 15;

	case T_SCOPE_RES:
		return 16;

	default:
		return 17;
	}

}

//returns more general of two types a and b
ATTRIB_TYPE getGeneralType(ATTRIB_TYPE a, ATTRIB_TYPE b)
{
	if(a == A_USERTYPE || b == A_USERTYPE)
		return A_USERTYPE;

	//see if compairing user types
	if(a >= T_BUILTINFUNCSTART)
		return a;

	int aval, bval;	//base type of each
	ATTRIB_TYPE retval;

	aval = (a & A_BASETYPES);
	bval = (b & A_BASETYPES);
	
	//choose more general
	if(aval > bval)
		retval = aval;
	else
		retval = bval;
	//remove modifiers
	retval &= A_BASETYPES;

	if( (a & A_UNSIGNED) && (b & A_UNSIGNED) )
		retval |= A_UNSIGNED;

	return retval;
}


