#include "common.h"

#include <stdio.h>


Constrainer::Constrainer(Scanner *s)
{
	scanner = s;
	numwarnings = 0;
	numerrors = 0;
}


void Constrainer::reportError(long error)
{
	printf("\nError: %s, line %d, %s:\n %s", scanner->SourceFile(),
		scanner->getCurrentLineNumber(), ErrorMsg[error], scanner->getCurrentLineWithPosition());
	numerrors++;
	
	if(numerrors > 100)
	{
		finalReport();
		exit(1);
	}

	char a;
	scanf("%c", &a);
}

void Constrainer::reportWarning(long error)
{
	printf("\nWarning: %s, line %d, %s:\n %s", scanner->SourceFile(),
		scanner->getCurrentLineNumber(), ErrorMsg[error], scanner->getCurrentLineWithPosition());
	numwarnings++;

	char a;
	scanf("%c", &a);
}

void Constrainer::finalReport()
{
	printf("\n*** %d Error(s), %d Warning(s)\n", numerrors, numwarnings);
}

bool Constrainer::validForCompile()
{
	return (numerrors == 0);
}

