//********WILL WANT TO ADD MANY OPTIONS TO CONSTRAINER


//error messages passed to constrainer
enum CompileError
{
	ERROR_TYPENOTSPECIFIED			=  0,	//if doesn't find preceding type of declaration
	ERROR_IDENTIFIERMISSING			=  1,	//missing identifier, e.g. const char ;
	ERROR_INVALIDIDENTIFIER			=  2,	//invalid identifier, such as int { or int ;
	ERROR_REPEATEDQUALIFIER			=  3,	//repeated qualifier, e.g. const const int i
	ERROR_QUALIFIEDCLASS			=  4,	//qualifier in class definition: unsigned class t...
	ERROR_SYMBOLDEFINED				=  5,	//symbol has already been defined
	ERROR_RECURSIVEINCLUDE			=  6,	//recursion from including files
	ERROR_UNEXPECTEDENDOFFILE		=  7,	//unexpected end of file
	ERROR_INVALIDSYMBOL				=  8,	//invalid symbol
	ERROR_MEMBERINITIALIZATION		=  9,	//class member initialization in definition
	ERROR_NESTEDCLASSDEFINITION		= 10,	//nested class definitions
	ERROR_INITMUSTBECONSTANT		= 11,	//initialization value must be a constant
	ERROR_INVALIDTYPE				= 12,	//invalid type
	ERROR_CONSTANTNOTINIT			= 13,	//constant value not initialized
	ERROR_CONSTANTREQUIRED			= 14,	//constant required
	ERROR_BRACKETREQUIRED			= 15,	//bracket required
	ERROR_ARRAYNOLENGTHNOINIT		= 16,	//array with no size or initialization
	ERROR_ARRAYINITTOOLONG			= 17,	//array initialization too long for specified size
	ERROR_ARYTOOLARGEFORCOMPILE		= 18,	//array initialization to large for compiler
	ERROR_DUPLICATEPROTOTYPE		= 19,	//duplicate function prototype
	ERROR_SCOPEDFUNCDEFNOTGLOBAL	= 20,	//scoped function definition not global
	ERROR_NOTCLASSMEMBER			= 21,	//not a class member
	ERROR_FUNCTALREADYDEFINED		= 22,	//function already defined
	ERROR_UNDEFINEDIDENTIFIER		= 23,	//undefined identifier
	ERROR_INVALIDIMMEDIATE			= 24,	//invalid immediate
	ERROR_ILLEGALUSEOFSYMBOL		= 25,	//illegal use of symbol
	ERROR_UNBALANCEDPARENTHESES		= 26,	//unbalanced parentheses
	ERROR_MISSINGLEFTPARENTHESES	= 27,	//missing left parentheses
	ERROR_PRECEDINGQUALIFIER		= 28,	//invalid qualifier preceding statement
	ERROR_EMPTYLANGUAGECONSTRUCT	= 29,	//empty language construct (empty parentheses or array)
	ERROR_ILLEGALOPPERATORUSE		= 30,	//illegal use of opperator
	ERROR_MISMATCHEDBRACKETS		= 31,	//mismatched brackets
	ERROR_NONINTEGERARRAYINDEX		= 32,	//non integer array index
	ERROR_INDEXEDNONARRAYTYPE		= 33,	//indexed non-array type
	ERROR_UNBALANCEDBRACKETS		= 34,	//unbalanced brackets
	ERROR_ILLEGALMEMBEROF			= 35,	//illegal use of member of opperator
	ERROR_ILLEGALUSEOFSTRING		= 36,	//illegal use of immediate string
	ERROR_UNDEFINEDFUNCTION			= 37,	//could not find matching function
	ERROR_CONTROLNOTINLOOP			= 38,	//control (break, continue) used outside of loop
	ERROR_PCLASSATTRIBUTEACCESS		= 39,	//cannot access an attribute of a pclass
	ERROR_PARALLELCONTROLSTATEMENTS	= 40,	//control statements cannot be in parallel block
	ERROR_PARALLELVARIABLEDECLARED	= 41,	//variable declared within a parellel block
	ERROR_INITIALIZEDEXTERNAL		= 42,	//cannot initialize external
	ERROR_SCOPEDEXTERNAL			= 43,	//scoped external
	ERROR_USERTYPESNOTALLOWED		= 44,	//user types not allowed as arguements yet (pass by calling member of class)

};

//const int numErrorMsgs = 6;

const char ErrorMsg[][92] =
{
	//msg										name							number
	"Type Declaration Missing",					//ERROR_TYPENOTSPECIFIED			 0
	"Identifier Missing",						//ERROR_IDENTIFIERMISSING			 1
	"Invalid Identifier",						//ERROR_INVALIDIDENTIFIER			 2
	"Repeated Qualifier",						//ERROR_REPEATEDQUALIFIER			 3
	"Qualified Class",							//ERROR_QUALIFIEDCLASS				 4
	"Symbol already defined",					//ERROR_SYMBOLDEFINED				 5
	"Recursive Include",						//ERROR_RECURSIVEINCLUDE			 6
	"Unexpected End of File",					//ERROR_UNEXPECTEDENDOFFILE			 7
	"Invalid Symbol",							//ERROR_INVALIDSYMBOL				 8
	"Cannot initialize variable in class",		//ERROR_MEMBERINITIALIZATION		 9
	"Nested Class Definitions",					//ERROR_NESTEDCLASSDEFINITION		10
	"Initialization Value must be a constant",	//ERROR_INITMUSTBECONSTANT			11
	"Invalid Type",								//ERROR_INVALIDTYPE					12
	"Constant not initialized",					//ERROR_CONSTANTNOTINIT				13
	"Constant Required",						//ERROR_CONSTANTREQUIRED			14
	"Bracket Required",							//ERROR_BRACKETREQUIRED				15
	"Array requires size or initialization",	//ERROR_ARRAYNOLENGTHNOINIT			16
	"Array initialization to long",				//ERROR_ARRAYINITTOOLONG			17
	"Array initialization to long for compiler",//ERROR_ARYTOOLARGEFORCOMPILE		18
	"Duplicate function prototype",				//ERROR_DUPLICATEPROTOTYPE			19
	"Scoped function definition not global",	//ERROR_SCOPEDFUNCDEFNOTGLOBAL		20
	"Not a member of specified class",			//ERROR_NOTCLASSMEMBER				21
	"Function already defined",					//ERROR_FUNCTALREADYDEFINED			22
	"Undefined Identifier",						//ERROR_UNDEFINEDIDENTIFIER			23
	"Invalid Immediate Usage",					//ERROR_INVALIDIMMEDIATE			24
	"Illegal use of symbol",					//ERROR_ILLEGALUSEOFSYMBOL			25
	"Unbalanced parentheses",					//ERROR_UNBALANCEDPARENTHESES		26
	"Left Parentheses required",				//ERROR_MISSINGLEFTPARENTHESES		27
	"Invalid qualifier preceding statement",	//ERROR_PRECEDINGQUALIFIER			28
	"Empty language construct",					//ERROR_EMPTYLANGUAGECONSTRUCT		29
	"Illegal use of opperator",					//ERROR_ILLEGALOPPERATORUSE			30
	"Mismatched []'s",							//ERROR_MISMATCHEDBRACKETS			31
	"Non-integer array index",					//ERROR_NONINTEGERARRAYINDEX		32
	"Indexed non-array data type",				//ERROR_INDEXEDNONARRAYTYPE			33
	"Unbalanced brackets",						//ERROR_UNBALANCEDBRACKETS			34
	"Illegal use of member of opperator",		//ERROR_ILLEGALMEMBEROF				35
	"Illegal use of immediate string",			//ERROR_ILLEGALUSEOFSTRING			36
	"Could not find matching function",			//ERROR_UNDEFINEDFUNCTION			37
	"Statement must be used within loop",		//ERROR_CONTROLNOTINLOOP			38
	"Cannot access an attribute of a pclass",	//ERROR_PCLASSATTRIBUTEACCESS		39
	"Control statements used in parallel block",//ERROR_PARALLELCONTROLSTATEMENTS	40
	"Variable declaration in parallel block",	//ERROR_PARALLELVARIABLEDECLARED	41
	"Cannot initialize external",				//ERROR_INITIALIZEDEXTERNAL			42
	"Scoped External",							//ERROR_SCOPEDEXTERNAL				43
	"User types and arrays not allowed as arguements yet (pass by calling member of class)", //ERROR_USERTYPESNOTALLOWED	44


};


class Constrainer
{
public:
	Constrainer(Scanner *s);

	void reportError(long error);
	void reportWarning(long warning);

	void finalReport();	//call when done parsing

	bool validForCompile();	//returns true if ok to compile

private:
	
	Scanner *scanner;
	int numerrors;
	int numwarnings;
};

