#include "common.h"

void CodeGenerator_i86::PeepholeOptimization()
{
	if(icode == NULL)
		return;

	//remove everything that adds or subtracts 0 to something (redundant)
	for(i86instruct *instr = icode; instr != NULL && instr->next != NULL; instr = instr->next)
	{
		if(instr->next->instr == iADD || instr->next->instr == iSUB)
		{
			if( (instr->next->op1a == iIMMD || instr->next->op1a == iIMMW || instr->next->op1a == iIMMB)
			&& instr->next->l_immediate == 0)
			{

				i86instruct *temp = instr->next;
				instr->next = temp->next;
				delete temp;
			}
		}

		if(instr->next->instr == iMOV)
		{
			if( (instr->next->op1a & iREGISTER)
				&& (instr->next->op2a & iREGISTER)
				&& (instr->next->op1a == instr->next->op2a) )
			{
				i86instruct *temp = instr->next;
				instr->next = temp->next;
				delete temp;
			}
		}

	}

}

