#!/usr/bin/perl -w
############################
#
# loader.pl
# this program resides on all machines in a
# system to be used with paraC.  when it recieves
# a message via tcp on port 13013, it ftp's the
# respective file from the server (specified 
# in command line), and then begins execution.

use IO::Socket;
use Net::FTP;

require Auth;

my $pid = 0;

print "ftp location: ";
my $headnode = <>;
chomp $headnode;
print "username: ";
my $headnodelogin = <>;
chomp $headnodelogin;
print "password: ";
my $headnodepassword = <>;
chomp $headnodepassword;


#$s = new IO::Socket::INET(LocalHost => '127.0.0.1');
#$mysockaddr = getsockname($s);
#my ($port, $myaddr) = sockaddr_in($mysockaddr);
#printf "Connect to %s [%s]\n", 
#    scalar gethostbyaddr($myaddr, AF_INET),
#    inet_ntoa($myaddr);


print "starting server\n";
$sock = new IO::Socket::INET( #ignore LocalHost parameter -only used if > 1 NIC
			     LocalPort => 13013,
			     Proto => 'tcp',
			     Reuse => 1,
			     Listen => 15,
			     );

die "socket could not be created: $!\n" unless $sock;

while($new_sock = $sock->accept())
{
    print "accepted connection\n";

    #get random value, send, and compair authenticized results
    my $auth_test = int rand 4000000000;
    print $new_sock "$auth_test\n";
    my $auth_val = <$new_sock>;
    
    if($auth_val != Auth::authenticate_value($auth_test))
    {
	print "invalid authentication, quitting...\n";
	last;
    }
    
    $todo = <$new_sock>;
    chomp $todo;
    
    if($todo =~ /^go .*/)
    {
	$todo =~ s/^go *//o;
	
	#if running, start over
	if($pid)
	{
	    print "terminating parallel server\n";
	    kill 9, $pid;
	}
	
	print "starting parallel server: $todo\n";
	$pid = fork();
	if($pid == 0)
	{
	    #ftp file over
#	    $ftp = Net::FTP->new($headnode);
#	    die "ftp could not connect: $!" unless $ftp;
#	    $ftp->login($headnodelogin, $headnodepassword);
#	    $ftp->get("$todo");
#	    $ftp->quit();
	    
#	    system "chmod 755 $todo";
	    
	    exec "./$todo\n";
	}
	elsif(!defined $pid)
	{
	    die "Error forking\n";
	}
    }
    elsif($todo =~ /^stop/)
    {
	if($pid)
	{
	    print "terminating parallel module\n";
	    kill 9, $pid;
	    wait();
	}
	else
	{
	    print "termination request ignored: no parallel server running\n";
	}
    }
    elsif($todo =~ /^get .*/)
    {
	$todo =~ s/^get *//o;
	print "recieving file $todo\n";
	#ftp file over
	$ftp = Net::FTP->new($headnode);
	die "ftp could not connect: $!" unless $ftp;
	$ftp->login($headnodelogin, $headnodepassword);
	$ftp->get("$todo");
	$ftp->quit();
	print "recieved file $todo successfully\n";
    }
    elsif($todo =~ /^msg .*/)
    {
	$todo =~ s/^msg *//o;
	print "message recieved: $todo\n";
    }
    else
    {
	print "error: invalid message recieved\n";
    }
    
}

wait();
close $sock;

