#!/usr/bin/perl -w
#####################
#
# launch.pl
# this program launches the specified program
# in the command line (full path required).
# it reads in nodes.dat and starts the program
# on all machines in the list

use IO::Socket;
require Auth;

$getfile = $ARGV[0];
chomp $getfile;

open FH, "nodes.dat";

while($target = <FH>)
{
    #don't do blank lines
    next if $target !~ m/\w/;

    #don't do comments
    next if $target =~ m/\/\//;

    chomp $target;

    $sock = new IO::Socket::INET( PeerAddr => "$target",
				  PeerPort => 13013,
				  Proto => 'tcp',
				  Reuse => 1,
				  );
    unless($sock)
    {
	print "Error opening socket on $target: $!\n" unless $sock;
	next;
    }

    #do authentication -get value, 'encrypt/scramble', send
    $auth_test = <$sock>;
    my $auth_value = Auth::authenticate_value($auth_test);
    print $sock "$auth_value\n";

    print $sock "get $getfile\n";
    close $sock;
}

close FH;
