#!/usr/bin/perl -w
#####################
#
# launch.pl
# this program launches the specified program
# in the command line (full path required).
# it reads in nodes.dat and starts the program
# on all machines in the list

use IO::Socket;

open FH, "connections.dat";

while($target = <FH>)
{
    #don't do blank lines
    next if $target !~ m/\w/;
    chomp $target;

    #break apart list
    my @data = split / /, $target;
    
    #first member of list is target address
    my $addr = shift @data;

    $sock = new IO::Socket::INET( PeerAddr => "$addr",
				  PeerPort => 13014,
				  Proto => 'tcp',
				  );
    unless($sock)
    {
	print "Error opening socket on $addr: $!\n" unless $sock;
	next;
    }

    print $sock "@data";
    close $sock;
}

close FH;
