class Scanner
{
public:
	Scanner(char *file, StringTable *st);
	~Scanner();

	TOKEN_ID getNextToken();

	//get more info
	StringTrieNode *getEndNameofLastGet(); //call this after getting a token
	//if getNextToken returns with a T_IMMEDIATE flag, call this
	char *getImmediateString();
	long getImmediateLong();	//also for last immediate character
	double getImmediateDouble();

	//used for included files
	int getCurPos();
	char *SourceFile();

	//used for error information
	int getCurrentLineNumber();
	char *getCurrentLineWithPosition();	//returns line number with <*> before current token
	//char *SourceFile(); also for error info


private:
	StringTable *stringtable;

	//last get values
	StringTrieNode *curStringEndName;
	char *curImmediateStr;
	long curImmediateLong;	//also for last immediate character
	double curImmediateDouble;

	//for included files.
	//NULL if not currently in other file
	Scanner *included_file;

	//actual source code text
	unsigned char *code;
	//length of code
	int codesize;
	//current character position in file
	int codepos;

	//debug info
	int curlinenumber;
	int prevtokenpos;
	char filename[256];
	int includedepth;	//number of nested includes
};

